/***************************************************************************
 *   Copyright (C) 2006 by Tomasz Salacinski   *
 *   distortion@vp.pl   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "kxmain.h"

#include <qcheckbox.h>

#include <kcombobox.h>
#include <knuminput.h>
#include <klineedit.h>
#include <ksqueezedtextlabel.h>

void kxMain::mouseIdentLineEditHandle()
{
QString num;
num = x->getSecUniqueNum("InputDevice", x->pointerTranslate(pointerSpinBox->value()));
if (mouseIdentLineEdit->text() == "") { mouseIdentLineEdit->undo(); }
if (mouseIdentLineEdit->text().contains(" ") > 0)  { mouseIdentLineEdit->backspace();  }
x->saveValue("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Identifier", 1, mouseIdentLineEdit->text());
x->replaceSomething("InputDevice \"" + num + "-" + x->mouseIdentBuf[kbdSpinBox->value()] + "\"", "InputDevice \"" + num + "-" + mouseIdentLineEdit->text() + "\"");
x->mouseIdentBuf[kbdSpinBox->value()] = mouseIdentLineEdit->text();
fillServerLayoutComponents();
}

void kxMain::kbdIdentLineEditHandle()
{
QString num;
num = x->getSecUniqueNum("InputDevice", x->kbdTranslate(kbdSpinBox->value()));
if (kbdIdentLineEdit->text() == "") { kbdIdentLineEdit->undo(); }
if (kbdIdentLineEdit->text().contains(" ") > 0)  { kbdIdentLineEdit->backspace();  }
x->saveValue("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "Identifier", 1, kbdIdentLineEdit->text());
x->replaceSomething("InputDevice \"" + num + "-" + x->kbdIdentBuf[kbdSpinBox->value()] + "\"", "InputDevice \"" + num + "-" + kbdIdentLineEdit->text() + "\"");
x->kbdIdentBuf[kbdSpinBox->value()] = kbdIdentLineEdit->text();
fillServerLayoutComponents();
}

void kxMain::scrIdenEditHanle()
{
QString num;
num = x->getSecUniqueNum("Screen",scrSpinBox->value());
if (screenIdentEdit->text() == "") { screenIdentEdit->undo(); }
if (screenIdentEdit->text().contains(" ") > 0)  { screenIdentEdit->backspace();  }
x->saveValue("Screen", scrSpinBox->value(), "Identifier", 1, screenIdentEdit->text());
x->replaceSomething("Screen \"" + num + "-" + x->screenIdentBuf[scrSpinBox->value()] + "\"", "Screen \"" + num + "-" + screenIdentEdit->text() + "\"");

x->screenIdentBuf[scrSpinBox->value()] = screenIdentEdit->text();
fillServerLayoutComponents();
}

void kxMain::mouseDeviceLineEditHandle()
{
if (mouseDeviceLineEdit->text() == "") { checkBox4->setChecked(TRUE); }
x->saveOption("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Device", 1, mouseDeviceLineEdit->text());
}

void kxMain::videoIdentEditHandle()
{
if (videoIdentEdit->text() == "") { videoIdentEdit->undo(); }
x->saveValue("Device", videoSpinBox->value(), "Identifier", 1, videoIdentEdit->text());


x->replaceSomething("Device \"" + x->deviceIdentBuf[videoSpinBox->value()] + "\"", "Device \"" + videoIdentEdit->text() + "\"");

x->deviceIdentBuf[videoSpinBox->value()] = videoIdentEdit->text();
fillScreen();
fillScreenCombos();
}

void kxMain::videoVendorEditHandle()
{
x->saveValue("Device", videoSpinBox->value(), "VendorName", 1, videoVendorEdit->text());
}

void kxMain::monitorIdentEditHandle()
{
if (monitorIdentEdit->text() == "") { monitorIdentEdit->undo(); }
x->saveValue("Monitor", monitorSpinBox->value(), "Identifier", 1, monitorIdentEdit->text());

x->replaceSomething("Monitor \"" + x->monitorIdentBuf[monitorSpinBox->value()] + "\"", "Monitor \"" + monitorIdentEdit->text() + "\"");

x->monitorIdentBuf[monitorSpinBox->value()] = monitorIdentEdit->text();
fillScreen();
fillScreenCombos();



}

void kxMain::monitorModelEditHandle()
{
x->saveValue("Monitor", monitorSpinBox->value(), "ModelName", 1, monitorModelEdit->text());
}

void kxMain::monitorVendorEditHandle()
{
x->saveValue("Monitor", monitorSpinBox->value(), "VendorName", 1, monitorVendorEdit->text());
}

void kxMain::videoComboBoxHandle()
{
x->saveValue("Device", videoSpinBox->value(), "Driver", 1, videoComboBox->text(videoComboBox->currentItem()).section(" - ", 0, 0));
}

void kxMain::mouseDeviceCheckBoxHandle()
{

if (!checkBox4->isChecked())
{
mouseDeviceLineEdit->setEnabled(TRUE);
deviceLabel->setEnabled(TRUE);

}

if (checkBox4->isChecked())
{
mouseDeviceLineEdit->setText("");
mouseDeviceLineEdit->setEnabled(FALSE);
deviceLabel->setEnabled(FALSE);
}

}

void kxMain::devMouseCheckBoxSave()
{
if (!checkBox4->isChecked())
{
QString noDev = tr("(None)");
mouseDeviceLineEdit->setText(noDev);
x->saveOption("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Device", 1, noDev);
}

if (checkBox4->isChecked())
{
x->removeOption("InputDevice", x->pointerTranslate(pointerSpinBox->value()), "Device");
}

}

void kxMain::xkbModelCheckBoxHandle()
{
if (checkBox40->isChecked())
{
comboBox9->setEnabled(FALSE);
textLabel11->setEnabled(FALSE);

}
if (!checkBox40->isChecked())
{

comboBox9->setEnabled(TRUE);
textLabel11->setEnabled(TRUE);
}

}

void kxMain::xkbModelComboHandle()
{
x->saveOption("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "XkbModel", 1, comboBox9->text(comboBox9->currentItem()));
}

void kxMain::xkbModelCheckClicked()
{
if (checkBox40->isChecked())
{
x->removeOption("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "XkbModel");
}
if (!checkBox40->isChecked())
{
x->saveOption("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "XkbModel", 1, comboBox9->text(0));
comboBox9->setCurrentItem(0);
}


}

void kxMain::xkbLayoutComboHandle()
{
x->saveOption("InputDevice", x->kbdTranslate(kbdSpinBox->value()), "XkbLayout", 1, comboBox10->text(comboBox10->currentItem()).section(" - ", 0, 0));
}

